clear all

%% Block-example
n = 3;
k = 2;

t0 = [6, 4; 1, 7];
t1 = [5,1/2; -1/2i, 4];
t2 = [4, 2; 3+1i, 6];

a = [t0; t1; t2];

% Block-valued vector
h0 = [11, 1/2; 1i, 10];
h1 = [3, 1; -1, 2];
h2 = [7, 3; 2, 8];

b = [h0; h1; h2];

% Testing the multiplication
A = blkToep(a);
trueMult = A*b;
fastMult = fastToepMult(a, b);
trueMult - fastMult

% Testing the blkToep-function for Lower Traingular matrix
A_lt = blkToep(a, 'LT');
trueMult_lt = A_lt*b;
fastMult_lt = fastToepMult(a, b, 'LT');
trueMult_lt - fastMult_lt

% Testing the blkToep-function for Upper Traingular matrix
A_ut = blkToep(a, 'UT');
trueMult_ut = A_ut*b;
fastMult_ut = fastToepMult(a, b, 'UT');
trueMult_ut - fastMult_ut



